Bug 1241552 - Buffer overrun with pango_ft2_render_layout_line() with undersized FT_Bitmap.
Summary: Buffer overrun with pango_ft2_render_layout_line() with undersized FT_Bitmap.
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: pango
Version: 22
Hardware: x86_64
OS: Linux
unspecified
high
Target Milestone: ---
Assignee: Akira TAGOH
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-07-09 13:17 UTC by Peter TB Brett
Modified: 2015-07-21 08:13 UTC (History)
3 users (show)

Fixed In Version: pango-1.36.8-6.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-07-18 02:10:27 UTC
Type: Bug


Attachments (Terms of Use)

Description Peter TB Brett 2015-07-09 13:17:20 UTC
Description of problem:

pango installed from the F22 "updates" repo contains a critical bug that causes a buffer overrun on 64-bit architectures when rendering a glyph into a FT_Bitmap that is too small.

When pango 1.36.8 is built from source on the same system, no buffer overrun is observed (using valgrind).

Version-Release number of selected component (if applicable):

pango-1.36.8-5.fc22.x86_64

How reproducible:

Always.

Steps to Reproduce:

See http://quality.runrev.com/show_bug.cgi?id=15581 for detailed instructions for reproducing, plus logs.

Comment 1 Peter TB Brett 2015-07-09 14:09:00 UTC
I ran some more tests.  The following builds contain the buffer overrun bug:

- pango-1.36.8-5.fc22.x86_64 package
- Build from pango-1.36.8.tar.xz archive
- Build from pango git, tag 1.36.8

The following builds do *not* contain the buffer overrun:

- Build from pango git, tag 1.37.0
- Build from pango git, tag 1.37.1

Bisect indicates that the bug is fixed in upstream commit fafc7915:
https://git.gnome.org/browse/pango/commit/?id=fafc7915334be2dc7eb3952ea0598865a2246eff

That patch applies cleanly against 1.36.8, but backporting that patch alone doesn't appear to fix the issue.

Could 1.37.0 be built and distributed through F22 "updates" repo, please?

Comment 2 Fedora Update System 2015-07-10 06:16:09 UTC
pango-1.36.8-6.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/pango-1.36.8-6.fc22

Comment 3 Fedora Update System 2015-07-10 06:16:51 UTC
pango-1.36.8-6.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/pango-1.36.8-6.fc21

Comment 4 Fedora Update System 2015-07-13 19:06:06 UTC
Package pango-1.36.8-6.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing pango-1.36.8-6.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-11370/pango-1.36.8-6.fc21
then log in and leave karma (feedback).

Comment 5 Fedora Update System 2015-07-18 02:10:27 UTC
pango-1.36.8-6.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 6 Fedora Update System 2015-07-21 08:13:06 UTC
pango-1.36.8-6.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.